<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BuildingDetailed StructType
 * @subpackage Structs
 */
class BuildingDetailed extends Building
{
    /**
     * The applicationFeeRule
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $applicationFeeRule;
    /**
     * The ftbDeductable
     * @var float
     */
    public $ftbDeductable;
    /**
     * The ftbWithholdingPercentage
     * @var float
     */
    public $ftbWithholdingPercentage;
    /**
     * The ftbWithholdingType
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $ftbWithholdingType;
    /**
     * The maintenanceLaborSurchargeAmount
     * @var float
     */
    public $maintenanceLaborSurchargeAmount;
    /**
     * The maintenanceLaborSurchargeType
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $maintenanceLaborSurchargeType;
    /**
     * The maintenanceSpendingLimitAmount
     * @var float
     */
    public $maintenanceSpendingLimitAmount;
    /**
     * The maintenanceSpendingLimitTime
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $maintenanceSpendingLimitTime;
    /**
     * The moveInDays
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $moveInDays;
    /**
     * The reasonForPropertyLost
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $reasonForPropertyLost;
    /**
     * Constructor method for BuildingDetailed
     * @uses BuildingDetailed::setApplicationFeeRule()
     * @uses BuildingDetailed::setFtbDeductable()
     * @uses BuildingDetailed::setFtbWithholdingPercentage()
     * @uses BuildingDetailed::setFtbWithholdingType()
     * @uses BuildingDetailed::setMaintenanceLaborSurchargeAmount()
     * @uses BuildingDetailed::setMaintenanceLaborSurchargeType()
     * @uses BuildingDetailed::setMaintenanceSpendingLimitAmount()
     * @uses BuildingDetailed::setMaintenanceSpendingLimitTime()
     * @uses BuildingDetailed::setMoveInDays()
     * @uses BuildingDetailed::setReasonForPropertyLost()
     * @param string $applicationFeeRule
     * @param float $ftbDeductable
     * @param float $ftbWithholdingPercentage
     * @param string $ftbWithholdingType
     * @param float $maintenanceLaborSurchargeAmount
     * @param string $maintenanceLaborSurchargeType
     * @param float $maintenanceSpendingLimitAmount
     * @param string $maintenanceSpendingLimitTime
     * @param string $moveInDays
     * @param string $reasonForPropertyLost
     */
    public function __construct($applicationFeeRule = null, $ftbDeductable = null, $ftbWithholdingPercentage = null, $ftbWithholdingType = null, $maintenanceLaborSurchargeAmount = null, $maintenanceLaborSurchargeType = null, $maintenanceSpendingLimitAmount = null, $maintenanceSpendingLimitTime = null, $moveInDays = null, $reasonForPropertyLost = null)
    {
        $this
            ->setApplicationFeeRule($applicationFeeRule)
            ->setFtbDeductable($ftbDeductable)
            ->setFtbWithholdingPercentage($ftbWithholdingPercentage)
            ->setFtbWithholdingType($ftbWithholdingType)
            ->setMaintenanceLaborSurchargeAmount($maintenanceLaborSurchargeAmount)
            ->setMaintenanceLaborSurchargeType($maintenanceLaborSurchargeType)
            ->setMaintenanceSpendingLimitAmount($maintenanceSpendingLimitAmount)
            ->setMaintenanceSpendingLimitTime($maintenanceSpendingLimitTime)
            ->setMoveInDays($moveInDays)
            ->setReasonForPropertyLost($reasonForPropertyLost);
    }
    /**
     * Get applicationFeeRule value
     * @return string|null
     */
    public function getApplicationFeeRule()
    {
        return $this->applicationFeeRule;
    }
    /**
     * Set applicationFeeRule value
     * @param string $applicationFeeRule
     * @return \StructType\BuildingDetailed
     */
    public function setApplicationFeeRule($applicationFeeRule = null)
    {
        // validation for constraint: string
        if (!is_null($applicationFeeRule) && !is_string($applicationFeeRule)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($applicationFeeRule, true), gettype($applicationFeeRule)), __LINE__);
        }
        $this->applicationFeeRule = $applicationFeeRule;
        return $this;
    }
    /**
     * Get ftbDeductable value
     * @return float|null
     */
    public function getFtbDeductable()
    {
        return $this->ftbDeductable;
    }
    /**
     * Set ftbDeductable value
     * @param float $ftbDeductable
     * @return \StructType\BuildingDetailed
     */
    public function setFtbDeductable($ftbDeductable = null)
    {
        // validation for constraint: float
        if (!is_null($ftbDeductable) && !(is_float($ftbDeductable) || is_numeric($ftbDeductable))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($ftbDeductable, true), gettype($ftbDeductable)), __LINE__);
        }
        $this->ftbDeductable = $ftbDeductable;
        return $this;
    }
    /**
     * Get ftbWithholdingPercentage value
     * @return float|null
     */
    public function getFtbWithholdingPercentage()
    {
        return $this->ftbWithholdingPercentage;
    }
    /**
     * Set ftbWithholdingPercentage value
     * @param float $ftbWithholdingPercentage
     * @return \StructType\BuildingDetailed
     */
    public function setFtbWithholdingPercentage($ftbWithholdingPercentage = null)
    {
        // validation for constraint: float
        if (!is_null($ftbWithholdingPercentage) && !(is_float($ftbWithholdingPercentage) || is_numeric($ftbWithholdingPercentage))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($ftbWithholdingPercentage, true), gettype($ftbWithholdingPercentage)), __LINE__);
        }
        $this->ftbWithholdingPercentage = $ftbWithholdingPercentage;
        return $this;
    }
    /**
     * Get ftbWithholdingType value
     * @return string|null
     */
    public function getFtbWithholdingType()
    {
        return $this->ftbWithholdingType;
    }
    /**
     * Set ftbWithholdingType value
     * @param string $ftbWithholdingType
     * @return \StructType\BuildingDetailed
     */
    public function setFtbWithholdingType($ftbWithholdingType = null)
    {
        // validation for constraint: string
        if (!is_null($ftbWithholdingType) && !is_string($ftbWithholdingType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ftbWithholdingType, true), gettype($ftbWithholdingType)), __LINE__);
        }
        $this->ftbWithholdingType = $ftbWithholdingType;
        return $this;
    }
    /**
     * Get maintenanceLaborSurchargeAmount value
     * @return float|null
     */
    public function getMaintenanceLaborSurchargeAmount()
    {
        return $this->maintenanceLaborSurchargeAmount;
    }
    /**
     * Set maintenanceLaborSurchargeAmount value
     * @param float $maintenanceLaborSurchargeAmount
     * @return \StructType\BuildingDetailed
     */
    public function setMaintenanceLaborSurchargeAmount($maintenanceLaborSurchargeAmount = null)
    {
        // validation for constraint: float
        if (!is_null($maintenanceLaborSurchargeAmount) && !(is_float($maintenanceLaborSurchargeAmount) || is_numeric($maintenanceLaborSurchargeAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($maintenanceLaborSurchargeAmount, true), gettype($maintenanceLaborSurchargeAmount)), __LINE__);
        }
        $this->maintenanceLaborSurchargeAmount = $maintenanceLaborSurchargeAmount;
        return $this;
    }
    /**
     * Get maintenanceLaborSurchargeType value
     * @return string|null
     */
    public function getMaintenanceLaborSurchargeType()
    {
        return $this->maintenanceLaborSurchargeType;
    }
    /**
     * Set maintenanceLaborSurchargeType value
     * @param string $maintenanceLaborSurchargeType
     * @return \StructType\BuildingDetailed
     */
    public function setMaintenanceLaborSurchargeType($maintenanceLaborSurchargeType = null)
    {
        // validation for constraint: string
        if (!is_null($maintenanceLaborSurchargeType) && !is_string($maintenanceLaborSurchargeType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($maintenanceLaborSurchargeType, true), gettype($maintenanceLaborSurchargeType)), __LINE__);
        }
        $this->maintenanceLaborSurchargeType = $maintenanceLaborSurchargeType;
        return $this;
    }
    /**
     * Get maintenanceSpendingLimitAmount value
     * @return float|null
     */
    public function getMaintenanceSpendingLimitAmount()
    {
        return $this->maintenanceSpendingLimitAmount;
    }
    /**
     * Set maintenanceSpendingLimitAmount value
     * @param float $maintenanceSpendingLimitAmount
     * @return \StructType\BuildingDetailed
     */
    public function setMaintenanceSpendingLimitAmount($maintenanceSpendingLimitAmount = null)
    {
        // validation for constraint: float
        if (!is_null($maintenanceSpendingLimitAmount) && !(is_float($maintenanceSpendingLimitAmount) || is_numeric($maintenanceSpendingLimitAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($maintenanceSpendingLimitAmount, true), gettype($maintenanceSpendingLimitAmount)), __LINE__);
        }
        $this->maintenanceSpendingLimitAmount = $maintenanceSpendingLimitAmount;
        return $this;
    }
    /**
     * Get maintenanceSpendingLimitTime value
     * @return string|null
     */
    public function getMaintenanceSpendingLimitTime()
    {
        return $this->maintenanceSpendingLimitTime;
    }
    /**
     * Set maintenanceSpendingLimitTime value
     * @param string $maintenanceSpendingLimitTime
     * @return \StructType\BuildingDetailed
     */
    public function setMaintenanceSpendingLimitTime($maintenanceSpendingLimitTime = null)
    {
        // validation for constraint: string
        if (!is_null($maintenanceSpendingLimitTime) && !is_string($maintenanceSpendingLimitTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($maintenanceSpendingLimitTime, true), gettype($maintenanceSpendingLimitTime)), __LINE__);
        }
        $this->maintenanceSpendingLimitTime = $maintenanceSpendingLimitTime;
        return $this;
    }
    /**
     * Get moveInDays value
     * @return string|null
     */
    public function getMoveInDays()
    {
        return $this->moveInDays;
    }
    /**
     * Set moveInDays value
     * @param string $moveInDays
     * @return \StructType\BuildingDetailed
     */
    public function setMoveInDays($moveInDays = null)
    {
        // validation for constraint: string
        if (!is_null($moveInDays) && !is_string($moveInDays)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($moveInDays, true), gettype($moveInDays)), __LINE__);
        }
        $this->moveInDays = $moveInDays;
        return $this;
    }
    /**
     * Get reasonForPropertyLost value
     * @return string|null
     */
    public function getReasonForPropertyLost()
    {
        return $this->reasonForPropertyLost;
    }
    /**
     * Set reasonForPropertyLost value
     * @param string $reasonForPropertyLost
     * @return \StructType\BuildingDetailed
     */
    public function setReasonForPropertyLost($reasonForPropertyLost = null)
    {
        // validation for constraint: string
        if (!is_null($reasonForPropertyLost) && !is_string($reasonForPropertyLost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonForPropertyLost, true), gettype($reasonForPropertyLost)), __LINE__);
        }
        $this->reasonForPropertyLost = $reasonForPropertyLost;
        return $this;
    }
}
