<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Ledger StructType
 * @subpackage Structs
 */
abstract class Ledger extends ClientDataContainer
{
    /**
     * The items
     * Meta information extracted from the WSDL
     * - arrayType: tns1:LedgerItem[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\LedgerItem[]
     */
    public $items;
    /**
     * Constructor method for Ledger
     * @uses Ledger::setItems()
     * @param \StructType\LedgerItem[] $items
     */
    public function __construct(array $items = array())
    {
        $this
            ->setItems($items);
    }
    /**
     * Get items value
     * @return \StructType\LedgerItem[]|null
     */
    public function getItems()
    {
        return $this->items;
    }
    /**
     * This method is responsible for validating the values passed to the setItems method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItems method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemsForArrayConstraintsFromSetItems(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ledgerItemsItem) {
            // validation for constraint: itemType
            if (!$ledgerItemsItem instanceof \StructType\LedgerItem) {
                $invalidValues[] = is_object($ledgerItemsItem) ? get_class($ledgerItemsItem) : sprintf('%s(%s)', gettype($ledgerItemsItem), var_export($ledgerItemsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The items property can only contain items of type \StructType\LedgerItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set items value
     * @throws \InvalidArgumentException
     * @param \StructType\LedgerItem[] $items
     * @return \StructType\Ledger
     */
    public function setItems(array $items = array())
    {
        // validation for constraint: array
        if ('' !== ($itemsArrayErrorMessage = self::validateItemsForArrayConstraintsFromSetItems($items))) {
            throw new \InvalidArgumentException($itemsArrayErrorMessage, __LINE__);
        }
        $this->items = $items;
        return $this;
    }
    /**
     * Add item to items value
     * @throws \InvalidArgumentException
     * @param \StructType\LedgerItem $item
     * @return \StructType\Ledger
     */
    public function addToItems(\StructType\LedgerItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LedgerItem) {
            throw new \InvalidArgumentException(sprintf('The items property can only contain items of type \StructType\LedgerItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->items[] = $item;
        return $this;
    }
}
