<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnitAdvanceSearchCriteria StructType
 * @subpackage Structs
 */
class UnitAdvanceSearchCriteria extends AuditableDTOSearchCriteria
{
    /**
     * The buildingId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $buildingId;
    /**
     * The city
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $city;
    /**
     * The neighborhood
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $neighborhood;
    /**
     * The zipCodes
     * Meta information extracted from the WSDL
     * - arrayType: xsd:string[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var string[]
     */
    public $zipCodes;
    /**
     * Constructor method for UnitAdvanceSearchCriteria
     * @uses UnitAdvanceSearchCriteria::setBuildingId()
     * @uses UnitAdvanceSearchCriteria::setCity()
     * @uses UnitAdvanceSearchCriteria::setNeighborhood()
     * @uses UnitAdvanceSearchCriteria::setZipCodes()
     * @param int $buildingId
     * @param string $city
     * @param string $neighborhood
     * @param string[] $zipCodes
     */
    public function __construct($buildingId = null, $city = null, $neighborhood = null, array $zipCodes = array())
    {
        $this
            ->setBuildingId($buildingId)
            ->setCity($city)
            ->setNeighborhood($neighborhood)
            ->setZipCodes($zipCodes);
    }
    /**
     * Get buildingId value
     * @return int|null
     */
    public function getBuildingId()
    {
        return $this->buildingId;
    }
    /**
     * Set buildingId value
     * @param int $buildingId
     * @return \StructType\UnitAdvanceSearchCriteria
     */
    public function setBuildingId($buildingId = null)
    {
        // validation for constraint: int
        if (!is_null($buildingId) && !(is_int($buildingId) || ctype_digit($buildingId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($buildingId, true), gettype($buildingId)), __LINE__);
        }
        $this->buildingId = $buildingId;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\UnitAdvanceSearchCriteria
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get neighborhood value
     * @return string|null
     */
    public function getNeighborhood()
    {
        return $this->neighborhood;
    }
    /**
     * Set neighborhood value
     * @param string $neighborhood
     * @return \StructType\UnitAdvanceSearchCriteria
     */
    public function setNeighborhood($neighborhood = null)
    {
        // validation for constraint: string
        if (!is_null($neighborhood) && !is_string($neighborhood)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($neighborhood, true), gettype($neighborhood)), __LINE__);
        }
        $this->neighborhood = $neighborhood;
        return $this;
    }
    /**
     * Get zipCodes value
     * @return string[]|null
     */
    public function getZipCodes()
    {
        return $this->zipCodes;
    }
    /**
     * This method is responsible for validating the values passed to the setZipCodes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setZipCodes method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateZipCodesForArrayConstraintsFromSetZipCodes(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $unitAdvanceSearchCriteriaZipCodesItem) {
            // validation for constraint: itemType
            if (!is_string($unitAdvanceSearchCriteriaZipCodesItem)) {
                $invalidValues[] = is_object($unitAdvanceSearchCriteriaZipCodesItem) ? get_class($unitAdvanceSearchCriteriaZipCodesItem) : sprintf('%s(%s)', gettype($unitAdvanceSearchCriteriaZipCodesItem), var_export($unitAdvanceSearchCriteriaZipCodesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The zipCodes property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set zipCodes value
     * @throws \InvalidArgumentException
     * @param string[] $zipCodes
     * @return \StructType\UnitAdvanceSearchCriteria
     */
    public function setZipCodes(array $zipCodes = array())
    {
        // validation for constraint: array
        if ('' !== ($zipCodesArrayErrorMessage = self::validateZipCodesForArrayConstraintsFromSetZipCodes($zipCodes))) {
            throw new \InvalidArgumentException($zipCodesArrayErrorMessage, __LINE__);
        }
        $this->zipCodes = $zipCodes;
        return $this;
    }
    /**
     * Add item to zipCodes value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\UnitAdvanceSearchCriteria
     */
    public function addToZipCodes($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The zipCodes property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->zipCodes[] = $item;
        return $this;
    }
}
